/**
 *  Copyright (c) 1997-2013, tinygroup.org (luo_guo@live.cn).
 *
 *  Licensed under the GPL, Version 3.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *       http://www.gnu.org/licenses/gpl.html
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 * --------------------------------------------------------------------------
 *  版权 (c) 1997-2013, tinygroup.org (luo_guo@live.cn).
 *
 *  本开源软件遵循 GPL 3.0 协议;
 *  如果您不遵循此协议，则不被允许使用此文件。
 *  你可以从下面的地址获取完整的协议文本
 *
 *       http://www.gnu.org/licenses/gpl.html
 */
package org.tinygroup.plugin.loader.impl;

import java.net.URL;
import java.util.ArrayList;
import java.util.List;

import org.tinygroup.fileresolver.FileProcessor;
import org.tinygroup.i18n.I18nMessageFactory;
import org.tinygroup.i18n.I18nMessages;
import org.tinygroup.logger.Logger;
import org.tinygroup.logger.LoggerFactory;
import org.tinygroup.plugin.config.PluginInfo;
import org.tinygroup.plugin.loader.PluginLoader;

/**
 * 扫描工程目录的插件加载器
 * 
 * @author luoguo
 * 
 */
public class PluginLoaderImpl implements PluginLoader {
	private static Logger logger = LoggerFactory
			.getLogger(PluginLoaderImpl.class);
	private I18nMessages i18nMessages = I18nMessageFactory.geti18nMessages();
	private List<PluginInfo> pluginInfoList = new ArrayList<PluginInfo>();

	public List<PluginInfo> load(String path) {
		return pluginInfoList;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * org.tinygroup.plugin.loader.PluginLoader#remove(org.hundsun.
	 * opensource.plugin.config.PluginInfo)
	 */
	public void remove(PluginInfo plugin) {
		pluginInfoList.remove(plugin);

	}

	/**
	 * 加载url中的资源，调用fileprocessor.process方法
	 * 
	 * @param loader
	 * @param urls1
	 */
	public void resolveResource(ClassLoader loader, URL urls1[]) {

	}

	/**
	 * 移除url中的资源，调用fileprocessor.deprocess方法
	 * 
	 * @param loader
	 * @param urls1
	 */
	public void deResolveResource(ClassLoader loader, URL urls[]) {
	}

	public List<FileProcessor> getRemoveResourceProcessors(PluginInfo plugin) {
		return null;
	}

	public List<FileProcessor> getResourceProcessors(PluginInfo plugin) {
		return null;
	}

	public List<PluginInfo> listJar(String path) {
		return pluginInfoList;
	}

	public ClassLoader getLoader(PluginInfo plugin) {
		return this.getClass().getClassLoader();
	}

	public ClassLoader getPublicLoader() {
		return this.getClass().getClassLoader();
	}

	public void add(PluginInfo plugin) {
		pluginInfoList.add(plugin);

	}

}
